# Extended Listbox

[![Travis](https://img.shields.io/travis/ckotzbauer/extended-listbox.svg?branch=master)](https://travis-ci.org/ckotzbauer/extended-listbox?branch=master)
[![NPM](https://img.shields.io/npm/v/extended-listbox.svg)](https://www.npmjs.com/package/extended-listbox)
[![David](https://img.shields.io/david/ckotzbauer/extended-listbox.svg)](https://david-dm.org/ckotzbauer/extended-listbox)
[![David](https://img.shields.io/david/dev/ckotzbauer/extended-listbox.svg)](https://david-dm.org/ckotzbauer/extended-listbox)


**Extended Listbox** is a simple to use javascript component as powerful
alternative to the HTML `<select>` tag. The main problem of
`<select>` tag is that last one isn’t flexible for customization with
*CSS*. Extended Listbox solves this problem. This component creates a list
structure based on `<div>` tags. The configuration is completely in
JavaScript. It opens up great possibilities for customization. **No jquery is needed**.

In addition, this component provides other useful features like a search
bar or grouped items.


## Supported Browsers

- Edge latest
- Chrome latest
- Firefox latest


## Installation

Install with NPM:
```
npm install extended-listbox
```
TypeScript definitions are included in the npm package.


## Usage

Link the component and a stylesheet from your page.

```html

<!-- include javascript and stylesheet -->
<link href="/path/to/extended-listbox.css" rel="stylesheet">
<script src="/path/to/extended-listbox.js"></script>
```

## Size

| Type                             | Size     |
|----------------------------------|----------|
| Uncompressed, not minified       | 27,8 KB  |
| Uncompressed, minified           | 11,3 KB  |
| Compressed (gzip), not minified  | 5,1 KB   |
| Compressed (gzip), minified      | 3,3 KB   |


[Documentation](http://ckotzbauer.github.io/extended-listbox/documentation/latest/)
--------------
[License](https://github.com/ckotzbauer/extended-listbox/blob/master/LICENSE)
--------
[Changelog](https://github.com/ckotzbauer/extended-listbox/blob/master/doc/CHANGELOG.md)
----------
[Roadmap](https://github.com/ckotzbauer/extended-listbox/blob/master/doc/ROADMAP.md)
--------
